      include 'copyrght.def'
C
      integer function psl_savebitmap(filename)
C save the contents of the current bitmap to a file
C-----------------------------------------------------------------------
      implicit none
!MS$ATTRIBUTES C, REFERENCE :: psl_savebitmap
      character*80 filename
!      integer overwrite
!C overwrite is 1 if overwriting of an existing file is allowed
C-----------------------------------------------------------------------
      include 'pdfread.def'

      include 'pdfdefs.par'
      
      include 'pdf.cmn'
      include 'logic.cmn'

C-----------------------------------------------------------------------
      integer ln,i,cln
      integer lench

      ln = lench(filename)
      filename(ln+1:ln+1) = char(0)
      cln = context_length
      i = ps_writemap(filename,N_cards,table,cnum,context,cln)
      if (i .ne. 0) then
         psl_savebitmap = -1
         call warnmsg('savebitmap','unable to open/write file '//
     $        filename(:ln))
         call errcode('savebitmap',i)
         return
      endif
      psl_savebitmap = 0
      return
      end
C-----------------------------------------------------------------------
      integer function psl_readbitmap(filename,ilogic)
C read the contents of a saved bitmap from a file
C-----------------------------------------------------------------------
      implicit none
!MS$ATTRIBUTES C, REFERENCE :: psl_readbitmap
      character*80 filename
      integer ilogic
C ilogic determines the logic to be applied to the tables
C	0	 Match with table
C	1	 Add to table
C	2	 Remove from table
C	3	 File without current table
C	4	 Replace table with file
C-----------------------------------------------------------------------
      include 'pdfread.def'

      include 'pdfdefs.par'
      
      include 'pdf.cmn'
      include 'logic.cmn'

      integer ln,i,j
      integer lench

      INTEGER*4 tcnum, cln
      CHARACTER*(context_length) tCONTEXT(cnum_max)

      ln = lench(filename)
      filename(ln+1:ln+1) = char(0)
      cln = context_length
      i = ps_readmap(filename,j,table1,tcnum,tcontext,cln)
      if (i .ne. 0) then
         psl_readbitmap = -1
         call warnmsg('readbitmap','unable to open/read file '//
     $        filename(:ln))
         call errcode('readbitmap',i)
         return
      endif
      if (j .ne. N_cards) then
         psl_readbitmap = -2
         call warnmsg('readbitmap','bitmap on file '//
     $        filename(:ln)//
     $        ' has a different size than current database')
         return
      endif
      if (ilogic .ge. 4) then
         cnum = tcnum
         do i=1,cnum
            context(i) = tcontext(i)
         enddo
         call tblcopy(table1, table, N_cards) 
      else
         call tbllogic(ilogic,'File contents ('//filename(:ln)//')')
         do i=1,tcnum
            context(i+cnum) = '... '//tcontext(i)
         enddo
         cnum = cnum + tcnum
      endif

      psl_readbitmap = 0
      return
      end






